
#include <SPI.h>
#include <MFRC522.h>
#include <Servo.h>
#include <Adafruit_NeoPixel.h>
#include <LiquidCrystal_I2C.h> 
LiquidCrystal_I2C lcd(0x27,16,2);
#include <Wire.h> 
//Inclusión de librerías necesarias
#define PIN         6
#define NUM_LEDS   16 
Adafruit_NeoPixel pixels(NUM_LEDS, PIN, NEO_GRB + NEO_KHZ800); // Definición de las variables para los neopixeles

#define SS_PIN 10 // Definición del pin SS
#define RST_PIN 9 // Definición del Pin RST 
#define BUZZER 4 //buzzer pin
MFRC522 mfrc522(SS_PIN, RST_PIN);   // Create MFRC522 instance.
Servo servo1; 
Servo servo2; //definir nombre de servos

int interrupcionled = 0;
int r = 0;
int v = 0;
int a = 0;
int contadorcolor = 0;
// Definición de otras variables

void setup() 
{
  attachInterrupt(interrupcionled, leds, RISING); //Definición de la interrupción 1
  Serial.begin(9600);   // Inicializar el puerto serial
  SPI.begin();      // Initiate  SPI
  lcd.init();                      
  lcd.backlight(); //Inicialización de la pantalla lcd
  mfrc522.PCD_Init();   // Iniciar el modulo MFRC522
  servo1.attach(3); //pin del servo1
  servo2.attach(5); //pin del servo2
  servo2.write(0); // Posición inicial del servo 2
  pixels.begin();
  pixels.show(); //Inicialización de los neopixeles
  pinMode(BUZZER, OUTPUT);
  noTone(BUZZER); // Inicialización del buzzer
   r = 0;
   v = 255;
   a = 0;
   for (int i = 0; i < 16; i++) { //ciclo de cambio de color de los neopixeles
   pixels.setPixelColor(i, pixels.Color(r, v, a)); 
   pixels.show();
     }
  lcd.clear();
  lcd.setCursor(0,0);
  lcd.print("Puente elevadizo");
  Serial.println("Listo para iniciar"); // Información mostrada en la pantalla LCD
  Serial.println();

}

void leds(){
 static unsigned long last_interrupt_time = 0;
 unsigned long interrupt_time = millis();
 if (interrupt_time - last_interrupt_time > 200){// Detección de rebotes
  pixels.clear(); //Limpiar color anterior 
  if (contadorcolor == 0){
    r= 255;
    v= 0;
    a= 0; 
    // Definición del primer color
  for (int i = 0; i < 16; i++) { //ciclo de cambio de color de los neopixeles
    pixels.setPixelColor(i, pixels.Color(r, v, a)); 
    Serial.println(contadorcolor);
    pixels.show();
    contadorcolor = 1; //Cambio de la variable para el cambio de color
  }
  } else if (contadorcolor == 1){
    r = 255;
    v = 100;
    a = 0;
    //Definición del segundo color 
    for (int i = 0; i < 16; i++) { //ciclo de cambio de color de los neopixeles
    pixels.setPixelColor(i, pixels.Color(r, v, a)); 
    pixels.show();
    contadorcolor = 2;//Cambio de la variable para el cambio de color
    }
  }else if (contadorcolor == 2){
    r = 255;
    v = 255;
    a = 0;
    //Definición del tercer color
    for (int i = 0; i < 16; i++) { //ciclo de cambio de color de los neopixeles
    pixels.setPixelColor(i, pixels.Color(r, v, a)); 
    pixels.show();
    contadorcolor = 3;//Cambio de la variable para el cambio de color
    }
  }else if (contadorcolor == 3){
    r = 100;
    v = 255;
    a = 0;
    //Definición del cuarto color
    for (int i = 0; i < 16; i++) { //ciclo de cambio de color de los neopixeles
    pixels.setPixelColor(i, pixels.Color(r, v, a)); 
    pixels.show();
    contadorcolor = 4;//Cambio de la variable para el cambio de color
    }
  }else if (contadorcolor == 4){
    r = 0;
    v = 255;
    a = 255;
    //Definición del quinto color
    for (int i = 0; i < 16; i++) { //ciclo de cambio de color de los neopixeles
    pixels.setPixelColor(i, pixels.Color(r, v, a)); 
    pixels.show();
    contadorcolor = 5;//Cambio de la variable para el cambio de color
    }
  }else if (contadorcolor == 5){
    r = 0;
    v = 0;
    a = 255;
    //Definición del sexto color
    for (int i = 0; i < 16; i++) { //ciclo de cambio de color de los neopixeles
    pixels.setPixelColor(i, pixels.Color(r, v, a)); 
    pixels.show();
    contadorcolor = 6;//Cambio de la variable para el cambio de color
    }
  }else if (contadorcolor == 6){
    r = 255;
    v = 0;
    a = 255;
    //Definición del séptimo color
    for (int i = 0; i < 16; i++) { //ciclo de cambio de color de los neopixeles
    pixels.setPixelColor(i, pixels.Color(r, v, a)); 
    pixels.show();
    }
    contadorcolor = 0;//Cambio de la variable para el cambio de color
  }

}
}

void loop() {

  if ( ! mfrc522.PICC_IsNewCardPresent()) 
  {
    return;
  }
  if ( ! mfrc522.PICC_ReadCardSerial()) // Detección de radiofrecuencias cercanas
  {
    return;
  }
  Serial.print("UID tag :");
  String content= "";
  byte letter;
  for (byte i = 0; i < mfrc522.uid.size; i++) // Ciclo para mostrar los datos de las tarjetas 
  {
     Serial.print(mfrc522.uid.uidByte[i] < 0x10 ? " 0" : " ");
     Serial.print(mfrc522.uid.uidByte[i], HEX);
     content.concat(String(mfrc522.uid.uidByte[i] < 0x10 ? " 0" : " "));
     content.concat(String(mfrc522.uid.uidByte[i], HEX));
  }
  Serial.println();
  Serial.print("Message : ");
  content.toUpperCase();
  if (content.substring(1) == "E7 5A 8B 19") // Identificación del código de la tarjeta 1 para levantar el puente
  {
    r = 255;
    v = 0;
    a = 0;
    for (int i = 0; i < 16; i++) { //ciclo de cambio de color de los neopixeles
    pixels.setPixelColor(i, pixels.Color(r, v, a)); 
    pixels.show();
     }
    lcd.clear();
    lcd.setCursor(0,0);
    lcd.print("Levantando el");
    lcd.setCursor(0,1);
    lcd.print("puente");
    Serial.println("Levantando el puente"); // Mostrar la información de la accíon actual en la pantalla lcd
    Serial.println();
    servo2.write(90); // Iniciar el movimiento del servo2 
    delay(1000);
    tone(BUZZER, 500);
    delay(300);
    noTone(BUZZER);
    delay(300);
    tone(BUZZER, 500);
    delay(300);
    noTone(BUZZER); // Sonido del buzzer 
    servo1.write(180); // Inicialización del movimiento del servo 1
    delay(2300);
    servo1.write(90);
    lcd.clear();
    lcd.setCursor(0,0);
    lcd.print("Puente arriba"); // Mostrar la información de la accíon actual en la pantalla lcd

  }
 
 else if (content.substring(1) == "07 69 C7 7B") { // Identificación del código de la tarjeta 2 para levantar el puente
    r = 0;
    v = 255;
    a = 0;
    for (int i = 0; i < 16; i++) { //ciclo de cambio de color de los neopixeles
    pixels.setPixelColor(i, pixels.Color(r, v, a)); 
    pixels.show();
     }
    lcd.clear();
    lcd.setCursor(0,0);
    lcd.print("Bajando el");
    lcd.setCursor(0,1);
    lcd.print("puente");
    Serial.println("Bajando el puente");// Mostrar la información de la accíon actual en la pantalla lcd
    Serial.println();
    servo2.write(0); // Inicialización del movimiento del servo2
    delay(1000);
    tone(BUZZER, 500);
    delay(300);
    noTone(BUZZER);
    delay(300);
    tone(BUZZER, 500);
    delay(300);
    noTone(BUZZER); // Sonido del buzzer 
    servo1.write(0); // Inicialización del movimiento del servo1
    delay(2100);
    servo1.write(90);
    lcd.clear();
    lcd.setCursor(0,0);
    lcd.print("Puente abajo");// Mostrar la información de la accíon actual en la pantalla lcd
  }
  

}
